PrefabFiles = {
	"wenyu",
	"woodensword",
	"woodensword_activated",
	"bagualight",
	"kansnow",
	"zhenelec",
	"zhenelecball",
	"duipoison",
	"duipoisoncloud",
	"xunwind",
	"liflame",
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/wenyu.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/wenyu.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/wenyu.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/wenyu.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/wenyu_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/wenyu_silho.xml" ),

    Asset( "IMAGE", "bigportraits/wenyu.tex" ),
    Asset( "ATLAS", "bigportraits/wenyu.xml" ),
	
	Asset( "IMAGE", "images/map_icons/wenyu.tex" ),
	Asset( "ATLAS", "images/map_icons/wenyu.xml" ),

}

local require = GLOBAL.require

table.insert(GLOBAL.CHARACTER_GENDERS.MALE, "wenyu")

AddMinimapAtlas("images/map_icons/wenyu.xml")
AddModCharacter("wenyu")

AddAction((function(v)
	local function findabsorber(act, default, cb)
		local doer = act.doer
		local target = act.target
		if doer.components.inventory then
			local item = doer.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)
			if item and item.components.absorber and item.components.absorber:CanAbsorb(target) then
				return cb(item.components.absorber, default)
			end
		end
		return default
	end
	v.id = "ABSORB"
	v.str = "Absorb"
	v.strfn = function(act)
		return findabsorber(act, v.str, function(absorber, default)
			if absorber.absorbstr and type(absorber.absorbstr) == "function" then
				return absorber.absorbstr(absorber.inst) or default
			else
				return absorber.absorbstr or default
			end
		end)
	end
	v.fn = function(act)
		return findabsorber(act, false, function(absorber, default)
			absorber:DoAbsorb(act.doer, act.target)
			return true
		end)
	end
	return v
end)(GLOBAL.Action(3, false, false, 2)))
AddStategraphActionHandler("wilson", GLOBAL.ActionHandler(GLOBAL.ACTIONS.ABSORB, "absorb"))
AddStategraphState("wilson", GLOBAL.State({
	name = "absorb",
	tags = {"doing", "busy", "canrotate"},
	onenter = function(inst)
		inst.AnimState:PlayAnimation("atk")
		inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_weapon")
	end,
	timeline = 
	{
		GLOBAL.TimeEvent(8*GLOBAL.FRAMES, function(inst) inst:PerformBufferedAction() end),
	},
	events = {
		GLOBAL.EventHandler("animover", function(inst)
			inst.sg:GoToState("idle") 
		end),
	},
}))

AddAction((function(v)
	v.id = "REACTIVATE"
	v.str = "Reactivate"
	v.fn = function(act)
		local doer = act.invobject
		if doer and doer.components.bagua then
			doer.components.bagua:Reactivate(act.doer)
			return true
		end
		return false
	end
	return v
end)(GLOBAL.Action(-1)))
AddStategraphActionHandler("wilson", GLOBAL.ActionHandler(GLOBAL.ACTIONS.REACTIVATE, "dolongaction"))

GLOBAL.modwenyu = {
	IsDLC2Enabled = function()
		return GLOBAL.IsDLCEnabled and GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC)
	end,
	IsDLC1Enabled = function()
		return GLOBAL.IsDLCEnabled and GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS)
	end,
	IsDLC1Or2Enabled = function()
		return GLOBAL.IsDLCEnabled and (GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) or GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC))
	end,
	LANGUAGE = GetModConfigData("LANGUAGE"),
}

local function deepmerge(t1, t2)
	for k,v in pairs(t2) do
		if not t1[k] then
			t1[k] = v
		elseif type(t1[k]) == "table" and type(v) == "table" then
			deepmerge(t1[k], v)
		else
			t1[k] = v
		end
	end
end

local mod_constants = require "modwenyu_constants"
deepmerge(GLOBAL, mod_constants)
